
#include "Arduino.h"
#include "ArduinoControl.h"


int Arduino_Interface(float *AC_Var) {

  static int Anzahl_Digital_Pins = 54;
  static int Anzahl_Analog_Pins = 16;
  static int Anzahl_Funktionen = 10;
  static int Anzahl_Variablen = 15;


  static int Timeout_counter = 0;
  static int index = 0;

  int digital_Pin[Anzahl_Digital_Pins];
  int analog_Pin[Anzahl_Analog_Pins];
  int ACvariablen[Anzahl_Variablen];
  int functions[Anzahl_Funktionen][2];




  char input_command [100];
  char input_char;


  Timeout_counter++;
  if (Timeout_counter >= 15) {
    index=0;
    Timeout_counter = 0;
    input_command[index] = '\0';
  }



  if (Serial.available() > 0) {


        while (Serial.available() > 0) {
                if(index < 99) {
                input_char = Serial.read();
                input_command[index] = input_char;
                index++;
                input_command[index] = '\0';
                }

               else if (index >= 99) {
                 index=0;
                 Timeout_counter = 0;
                 input_command[index] = '\0';
                 Serial.println("Fehler: Eingabe zu lang!");

                 while (Serial.read() >= 0) {
                  // nichts machen und den Buffer leeren
                 }
                }
         }



            if ((input_command[0] == '#') and (input_command[1] == 's') and (input_command[strlen(input_command)-2] == '#') and (input_command[strlen(input_command)-1] == 'e')) {
            char * temp;
            char Command_Array [6][30];
            index=0;
            Timeout_counter = 0;

            Command_Array[0][0]='\0';  //A
            Command_Array[1][0]='\0';  //1
            Command_Array[2][0]='\0';  //R
            Command_Array[3][0]='\0';  //0
            Command_Array[4][0]='\0';  //#e
            Command_Array[5][0]='\0';


            temp = strtok (input_command,";"); // #s ausschneiden

            while (temp != NULL)
            {
              temp = strtok (NULL, ";");
              strcpy(Command_Array[index],temp);
              index++;
            }
            input_command[0]='\0';


            if (strcmp(Command_Array[0],"A") == 0) { // Typ Analog
                int Pin = atoi(Command_Array[1]);
                int Wert = atoi(Command_Array[3]);

                if (strcmp(Command_Array[2],"R") == 0) { // Lesemodus
                  analog_Pin[Pin] = Wert;
                }

                else if (strcmp(Command_Array[2],"W") == 0) { // Schreibmodus
                  analogWrite(Pin,Wert);
                }
            }


            else if (strcmp(Command_Array[0],"D") == 0) { // Typ Digital
                int Pin = atoi(Command_Array[1]);
                int Wert = atoi(Command_Array[3]);

                if (strcmp(Command_Array[2],"R") == 0) { // Lesemodus
                  digital_Pin[Pin] = Wert;
                }

                else if (strcmp(Command_Array[2],"W") == 0) { // Schreibmodus
                  digitalWrite(Pin,Wert);
                }
            }


            else if (strcmp(Command_Array[0],"V") == 0) { // Typ Variable
                int Nummer = atoi(Command_Array[1]);
                int Aktivieren = atoi(Command_Array[3]);

                if (strcmp(Command_Array[2],"R") == 0) { // Lesemodus
                  ACvariablen[Nummer] = Aktivieren;  // 1: ja   0: nein
                }

                else if (strcmp(Command_Array[2],"W") == 0) { // Schreibmodus
                  // noch nichts
                }
            }


            else if (strcmp(Command_Array[0],"F") == 0) { // Typ Funktion
                int Nummer = atoi(Command_Array[1]);
                int Aktivieren = atoi(Command_Array[3]);

                if (strcmp(Command_Array[2],"R") == 0) { // Lesemodus
                  functions[Nummer][0] = Aktivieren;  // 1: ja   0: nein
                }

                else if (strcmp(Command_Array[2],"W") == 0) { // Schreibmodus
                  // noch nichts
                }
            }

         } // nachricht dekodieren
    } // ende empfang





    Serial.print("#s");

    // Digitale Werte ausgeben
    for(int i = 0; i <= Anzahl_Digital_Pins-1; i++){
      if (digital_Pin[i] == 1) {
        int Wert = digitalRead(i);
        char temp[30];
        sprintf(temp, ";D,%d,%d", i, Wert);
        Serial.print(temp);
      }
    }

    // analoge Werte ausgeben
    for(int i = 0; i <= Anzahl_Analog_Pins-1; i++){
      if (analog_Pin[i] == 1) {
        int Wert = analogRead(i);
        char temp[30];
        sprintf(temp, ";A,%d,%d", i, Wert);
        Serial.print(temp);
      }
    }



     // Variablen ausgeben
    for(int i = 0; i <= Anzahl_Variablen-1; i++){
      if (ACvariablen[i] == 1) {
        char Wert[12];
        dtostrf(AC_Var[i], 1, 3, Wert);
        char temp[30];
        sprintf(temp, ";V,%d,", i);
        strcat (temp, Wert);
        Serial.print(temp);
      }
    }



     // Funktionswerte ausgeben
    for(int i = 0; i <= Anzahl_Funktionen-1; i++){
      if (functions[i][0] == 1) {
        int Wert = functions[i][1];
        char temp[30];
        sprintf(temp, ";F,%d,%d", i, Wert);
        Serial.print(temp);
      }
    }

   Serial.println(";#e");


} // End Function
